package lcsb.mapviewer.api.projects.models.bioEntities.elements;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import lcsb.mapviewer.api.BaseController;
import lcsb.mapviewer.services.SecurityException;

@RestController
public class ElementsController extends BaseController {
	@Autowired
	private ElementsRestImpl projectController;

	@RequestMapping(value = "/projects/{projectId}/models/{modelId}/bioEntities/elements/", method = { RequestMethod.GET },
			produces = { MediaType.APPLICATION_JSON_VALUE })
	public List<Map<String, Object>> getElements(//
			@PathVariable(value = "projectId") String projectId, //
			@PathVariable(value = "modelId") String modelId, //
			@RequestParam(value = "id", defaultValue = "") String id, //
			@RequestParam(value = "columns", defaultValue = "") String columns, //
			@RequestParam(value = "token") String token//
	) throws SecurityException {
		return projectController.getElements(projectId, id, columns, modelId, token);
	}

}